=== debian/changelog ===
sdl2-compat (2.28.50~git20240124~35695bd+ds-1) experimental; urgency=medium

  * New upstream snapshot
  * d/control: Require a compatible SDL3 snapshot
  * Drop patch from previous upload, applied upstream

 -- Simon McVittie <smcv@debian.org>  Wed, 24 Jan 2024 13:51:16 +0000

sdl2-compat (2.28.50~git20240121~1aae3d8+ds-1) experimental; urgency=medium

  * New upstream snapshot
  * d/control: Make the Maintainer consistent with other SDL packages
  * Bump required SDL3 snapshot to 2024-01-21.
    API changes for spinlocks and haptic feedback, among other things, mean
    that older snapshots are incompatible.
  * Add patch to fix test failure on 32-bit architectures

 -- Simon McVittie <smcv@debian.org>  Tue, 23 Jan 2024 10:30:59 +0000

sdl2-compat (2.28.50~git20240110~c5faaac+ds-1) experimental; urgency=medium

  * New package for experimental (Closes: #1060319)
    - Upstream source based on a git snapshot, there are no releases yet
    - Packaging based on a mixture of sdl12-compat and libsdl2
  * This package is experimental, and must not be uploaded to unstable
    until SDL3 is API- and ABI-stable.
  * Initial Debian delta:
    - d/copyright, d/p/test-Don-t-install-bundled-copy-of-unifont.patch:
      Repack to exclude some unnecessary vendored files from the test suite.
      To the best of my knowledge, everything we exclude is (meant to be)
      Free Software, we just don't want to keep track of the copyright and
      licensing status of files that are irrelevant to Debian.
    - d/p/Avoid-hard-coding-libdir-in-sdl2-config.patch:
      Be multi-arch co-installable
    - d/SDL_config.h, d/rules:
      Install a version of SDL_config.h that is backwards-compatible with
      what SDL2 traditionally provided.
      Upstream sdl2-compat currently uses SDL_config_minimal.h on Unix, but
      that version is missing lots of feature-test macros that games are
      probably relying on. Until this gets resolved upstream, we can avoid
      issues similar to #1039439 and #1012232 by providing our own
      relatively complete SDL_config.h.
    - d/p/test-Disable-audio-test-case-that-fails-in-a-chroot-conta.patch,
      Disable a test case that is not yet working

 -- Simon McVittie <smcv@debian.org>  Wed, 10 Jan 2024 15:12:55 +0000
