=== debian/control ===
Source: sdl2-compat
Priority: optional
Maintainer: Debian SDL packages maintainers <pkg-sdl-maintainers@lists.alioth.debian.org>
Uploaders:
 Simon McVittie <smcv@debian.org>,
 Stephen Kitt <skitt@debian.org>,
Build-Depends:
 cmake,
 debhelper-compat (= 13),
 libgl-dev <!nocheck> <!noinsttest>,
 libgles-dev [!hurd-any] <!nocheck> <!noinsttest>,
 libsdl3-dev (>= 3~git20240124~),
 libvulkan-dev <!nocheck> <!noinsttest>,
 libx11-dev <!nocheck> <!noinsttest>,
Standards-Version: 4.6.2
Section: libs
Homepage: https://github.com/libsdl-org/sdl2-compat
Vcs-Git: https://salsa.debian.org/sdl-team/sdl2-compat.git
Vcs-Browser: https://salsa.debian.org/sdl-team/sdl2-compat
Rules-Requires-Root: no

Package: libsdl2-compat
Architecture: any
Multi-Arch: same
Depends:
 libsdl3-0 (>= 3~git20240124~),
 ${misc:Depends},
 ${shlibs:Depends},
Pre-Depends:
 ${misc:Pre-Depends},
Description: SDL 2 binary compatibility library wrapping SDL 3
 sdl2-compat provides a binary compatible API for programs built
 against SDL 2, but using SDL 3.
 .
 If you are writing new code, please target SDL 3 directly (when it
 becomes stable) instead of using this layer. Debian packages should not
 depend or build-depend on this package: please use libsdl2-2.0-0 instead.
 .
 This package only provides the library, in a private location, so
 that it can be co-installed with libsdl2-2.0-0. It is intended for
 testing. To replace libsdl2-2.0-0 entirely, and use the compatibility
 layer with all SDL 2 programs, install libsdl2-compat-shim.

Package: libsdl2-compat-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Depends:
 libsdl2-compat-shim (= ${binary:Version}),
 libsdl3-dev (>= 3~git20240124~),
 pkgconf,
 ${misc:Depends},
 ${shlibs:Depends},
Pre-Depends:
 ${misc:Pre-Depends},
Conflicts:
 libsdl2-dev,
Provides:
 libsdl2-dev (= ${local:EquivalentVersion}),
Replaces:
 libsdl2-dev,
Description: libsdl2-dev replacement using SDL 3
 sdl2-compat provides a binary compatible API for programs built
 against SDL 2, but using SDL 3.
 .
 If you are writing new code, please target SDL 3 directly (when it
 becomes stable) instead of using this layer. Debian packages should not
 build-depend on this package: please use libsdl2-dev instead.
 .
 This package provides development files.

Package: libsdl2-compat-shim
Architecture: any
Multi-Arch: same
Depends:
 libsdl2-compat (= ${binary:Version}),
 ${misc:Depends},
Conflicts:
 libsdl2-2.0-0,
Replaces:
 libsdl2-2.0-0,
Provides:
 libsdl2-2.0-0 (= ${local:EquivalentVersion}),
Description: libsdl2-2.0-0 replacement using SDL 3
 sdl2-compat provides a binary compatible API for programs built
 against SDL 2, but using SDL 3.
 .
 If you are writing new code, please target SDL 3 directly (when it
 becomes stable) instead of using this layer. Debian packages should not
 depend or build-depend on this package: please use libsdl2-2.0-0 instead.
 .
 This package replaces libsdl2-2.0-0 with the SDL 3 compatibility
 layer, so that all SDL 2 programs will use it.

Package: libsdl2-compat-tests
Build-Profiles: <!noinsttest>
Section: misc
Architecture: any
Depends:
 libsdl2-compat (>= ${binary:Version}),
 ${misc:Depends},
 ${shlibs:Depends},
Pre-Depends:
 ${misc:Pre-Depends},
Description: SDL 2 binary compatibility library - tests
 sdl2-compat provides a binary compatible API for programs built
 against SDL 2, but using SDL 3.
 .
 If you are writing new code, please target SDL 3 directly (when it
 becomes stable) instead of using this layer. Debian packages should not
 depend or build-depend on this package.
 .
 This package provides automated and manual test programs.
