=== debian/watch ===
version=4

# TODO:
#opts="\
#    compression=gzip, \
#    dversionmangle=s/\+(?:git)?[0-9]*(?:\+g[0-9a-f]*)//, \
#    downloadurlmangle=s#/releases/tag/#/archive/refs/tags/#;s#((?:pre)?release-?@ANY_VERSION@)$#$1/@PACKAGE@-$2.tar.gz#, \
#    filenamemangle=s#(?:pre)?release-?@ANY_VERSION@#@PACKAGE@-$1.tar.gz#" \
#https://github.com/libsdl-org/@PACKAGE@/tags .*/releases/tag/release-?@ANY_VERSION@
#
# or:
#opts="mode=git" \
#https://github.com/libsdl-org/@PACKAGE@ \
#refs/tags/release-@ANY_VERSION@

opts="\
    mode=git, \
    compression=gzip, \
    dversionmangle=s/\+(?:git)?[0-9]*(?:\+g[0-9a-f]*)(?:\+(?:dfsg|ds)[0-9]*)//, \
    pretty=2.28.50~git%cd~%h+ds" \
https://github.com/libsdl-org/sdl2-compat \
HEAD
