## sdl2-compat 2.30.50~git20241004~e094ce8+ds

=== CMakeLists.txt ===
--- 
+++ 
@@ -3,7 +3,7 @@
 #        cmake -DSDL3_INCLUDE_DIRS=/opt/SDL3/include [other stuff ....]
 
 cmake_minimum_required(VERSION 3.0.0...3.5)
-project(sdl2_compat VERSION 2.28.50 LANGUAGES C)
+project(sdl2_compat VERSION 2.30.50 LANGUAGES C)
 
 if(POLICY CMP0074)
   # CMP0074: find_package() uses <PackageName>_ROOT variables.
@@ -176,16 +176,23 @@
   endif()
 endif()
 
-if(WINDOWS_STORE)
-  list(APPEND SDL2COMPAT_SRCS
-    "src/sdl2_compat_winrt.cpp"
-  )
-endif()
-
 if(WIN32)
   list(APPEND SDL2COMPAT_SRCS
+    "src/sdl2_mslibc.c"
     "src/version.rc"
   )
+endif()
+if(MSVC)
+  if(SDL_CPU_X64)
+    list(APPEND SDL2COMPAT_SRCS
+      "src/sdl2_mslibc_x64.masm"
+    )
+    enable_language(ASM_MASM)
+    set_property(SOURCE "src/sdl2_mslibc_x64.masm" PROPERTY LANGUAGE "ASM_MASM")
+  elseif(SDL_CPU_ARM32 OR SDL_CPU_ARM64)
+    # FIXME: ARM assembler (armasm.exe/armasm64.exe) is NOT ASM_MASM, and does currently not work with CMake
+    # (https://gitlab.kitware.com/cmake/cmake/-/issues/18912)
+  endif()
 endif()
 
 if(APPLE)
@@ -215,6 +222,9 @@
   set_property(TARGET SDL2 PROPERTY BUILD_RPATH $<TARGET_FILE_DIR:SDL3::SDL3-shared>)
 endif()
 
+if(MSVC AND SDL_CPU_X64)
+  target_compile_options(SDL2 PRIVATE "$<$<COMPILE_LANGUAGE:ASM_MASM>:/nologo>")
+endif()
 set(EXTRA_CFLAGS )
 if(CMAKE_C_COMPILER_ID MATCHES "Clang|GNU")
   set(EXTRA_CFLAGS "${EXTRA_CFLAGS} -Wall")
@@ -296,22 +306,20 @@
     if(SDL_CPU_X86)
       target_link_libraries(SDL2 PRIVATE clang_rt.builtins-i386)
     endif()
+    if(SDL_CPU_X64)
+      target_link_libraries(SDL2 PRIVATE clang_rt.builtins-x86_64)
+    endif()
   else()
-    if(SDL_CPU_X86 OR SDL_CPU_ARM32)
-      # 32-bit architectures need libgcc for emulating 64-bit operations (e.g. 64-bit division)
-      target_link_libraries(SDL2 PRIVATE gcc)
-      set_property(TARGET SDL2 APPEND_STRING PROPERTY LINK_FALGS " -static-libgcc")
-    endif()
-  endif()
-endif()
-if(WINDOWS_STORE)
-  set_target_properties(SDL2 PROPERTIES DEFINE_SYMBOL "SDL_BUILDING_WINRT=1")
-  target_compile_options(SDL2 PRIVATE "-ZW")
-elseif(MSVC)
+    # need libgcc for emulating 64-bit operations (e.g. 64-bit division) or __chkstk_ms()
+    target_link_libraries(SDL2 PRIVATE gcc)
+    set_property(TARGET SDL2 APPEND_STRING PROPERTY LINK_FALGS " -static-libgcc")
+  endif()
+endif()
+if(MSVC)
   # Don't try to link with the default set of libraries.
-  target_compile_options(SDL2 PRIVATE /GS-)
+  target_compile_options(SDL2 PRIVATE "$<$<COMPILE_LANGUAGE:C>:/GS->")
   if(SDL_CPU_X86)  # don't emit SSE2 in x86 builds
-    target_compile_options(SDL2 PRIVATE /arch:SSE)
+    target_compile_options(SDL2 PRIVATE "$<$<COMPILE_LANGUAGE:C>:/arch:SSE>")
   endif()
   if(NOT MSVC_CLANG AND NOT SDL_CPU_ARM32)
     set_property(TARGET SDL2 APPEND_STRING PROPERTY LINK_FLAGS " /NODEFAULTLIB")
@@ -320,16 +328,3 @@
   foreach(flag_var
     CMAKE_C_FLAGS CMAKE_C_FLAGS_DEBUG CMAKE_C_FLAGS_RELEASE
     CMAKE_C_FLAGS_MINSIZEREL CMAKE_C_FLAGS_RELWITHDEBINFO)
-    string(REGEX REPLACE "/RTC(su|[1su])" "" ${flag_var} "${${flag_var}}")
-  endforeach(flag_var)
-endif()
-
-# !!! FIXME: what needs to be done for sdl2-compat? Look into this.
-## SDL2main library...
-if(WIN32)
-    add_library(SDL2main STATIC src/SDLmain/windows/SDL_windows_main.c)
-    target_link_libraries(SDL2main PRIVATE shell32)
-else()
-    add_library(SDL2main STATIC src/SDLmain/dummy/SDL_dummy_main.c)
-endif()
-add_library(SDL2::SDL2main ALIAS SDL2main)
