=== debian/changelog ===
sdl2-compat (2.30.50~git20241004~e094ce8+ds-1) experimental; urgency=medium

  * New upstream snapshot, corresponding to SDL3 prerelease 3.1.3
    - d/control: (Build-)Depend on corresponding libsdl3 prerelease

 -- Simon McVittie <smcv@debian.org>  Fri, 04 Oct 2024 18:05:06 +0100

sdl2-compat (2.30.50~git20240917~cbc8bd0+ds-1) experimental; urgency=medium

  * New upstream snapshot
    - d/control: (Build-)Depend on a corresponding libsdl3 snapshot

 -- Simon McVittie <smcv@debian.org>  Tue, 17 Sep 2024 21:08:34 +0100

sdl2-compat (2.30.50~git20240903~8f31681+ds-1) experimental; urgency=medium

  * New upstream snapshot
    - d/control: (Build-)Depend on a corresponding libsdl3 snapshot

 -- Simon McVittie <smcv@debian.org>  Tue, 03 Sep 2024 21:29:58 +0100

sdl2-compat (2.30.50~git20240729~b50099f+ds-1) experimental; urgency=medium

  * New upstream snapshot
    - d/control: (Build-)Depend on a corresponding libsdl3 snapshot
    - d/copyright: Update
  * Add a Lintian override for hardening-no-fortify-functions in some tests

 -- Simon McVittie <smcv@debian.org>  Tue, 30 Jul 2024 16:43:48 +0100

sdl2-compat (2.30.50~git20240507~1bee522+ds-1) experimental; urgency=medium

  * New upstream snapshot, corresponding to SDL3 prerelease 3.1.2
    - Depend on a corresponding SDL3 prerelease
  * d/p/Bypass-SDL3-s-version-of-SDL_GetWindowGrab-SDL_SetWindowG.patch:
    Drop, no longer required

 -- Simon McVittie <smcv@debian.org>  Thu, 20 Jun 2024 14:51:47 +0100

sdl2-compat (2.30.50~git20240325~44fec4d+ds-1) experimental; urgency=medium

  * New upstream snapshot
  * d/control: Require SDL3 prerelease 3.1.0
  * d/p/Bypass-SDL3-s-version-of-SDL_GetWindowGrab-SDL_SetWindowG.patch:
    Add patch reinstating compatibility with SDL 3.1.0 prerelease

 -- Simon McVittie <smcv@debian.org>  Tue, 26 Mar 2024 17:16:34 +0000

sdl2-compat (2.30.50~git20240202~4701ef7+ds-1) experimental; urgency=medium

  * New upstream snapshot
  * Bump version number to correspond to 2.30.x branch of classic SDL2
  * d/control: Require a corresponding libsdl3

 -- Simon McVittie <smcv@debian.org>  Fri, 02 Feb 2024 15:51:14 +0000

sdl2-compat (2.28.50~git20240128~de26d69+ds-1) experimental; urgency=medium

  * New upstream snapshot
  * d/control: Require a corresponding libsdl3

 -- Simon McVittie <smcv@debian.org>  Mon, 29 Jan 2024 14:46:46 +0000
