=== debian/control ===
--- 
+++ 
@@ -9,10 +9,10 @@
  debhelper-compat (= 13),
  libgl-dev <!nocheck> <!noinsttest>,
  libgles-dev [!hurd-any] <!nocheck> <!noinsttest>,
- libsdl3-dev (>= 3~git20240124~),
+ libsdl3-dev (>= 3.1.3~),
  libvulkan-dev <!nocheck> <!noinsttest>,
  libx11-dev <!nocheck> <!noinsttest>,
-Standards-Version: 4.6.2
+Standards-Version: 4.7.0
 Section: libs
 Homepage: https://github.com/libsdl-org/sdl2-compat
 Vcs-Git: https://salsa.debian.org/sdl-team/sdl2-compat.git
@@ -23,7 +23,7 @@
 Architecture: any
 Multi-Arch: same
 Depends:
- libsdl3-0 (>= 3~git20240124~),
+ libsdl3-0 (>= 3.1.3~),
  ${misc:Depends},
  ${shlibs:Depends},
 Pre-Depends:
@@ -47,7 +47,7 @@
 Multi-Arch: same
 Depends:
  libsdl2-compat-shim (= ${binary:Version}),
- libsdl3-dev (>= 3~git20240124~),
+ libsdl3-dev (>= 3.1.3~),
  pkgconf,
  ${misc:Depends},
  ${shlibs:Depends},
