=== debian/watch ===
--- 
+++ 
@@ -17,6 +17,6 @@
     mode=git, \
     compression=gzip, \
     dversionmangle=s/\+(?:git)?[0-9]*(?:\+g[0-9a-f]*)(?:\+(?:dfsg|ds)[0-9]*)//, \
-    pretty=2.28.50~git%cd~%h+ds" \
+    pretty=2.30.50~git%cd~%h+ds" \
 https://github.com/libsdl-org/sdl2-compat \
 HEAD
